import{ world, MinecraftBlockTypes, BlockPermutation, system, EntityTypes, ItemTypes, BlockProperties, ItemStack} from "@minecraft/server";
import { questList } from "./data/quest_list"
import { guildShopList } from "./data/guild_shop_list"

//this function is for future compatibility :)
if(EntityTypes.get("aq:quest_loader")){
	var loopId = system.runInterval(() => {
		if(Array.from(world.getPlayers())[0].location){
			let playerLoc = Array.from(world.getPlayers())[0].location;
			let spawnLoc = { x: playerLoc.x, y: playerLoc.y, z: playerLoc.z };
			let summon_quest_list = world.getDimension("minecraft:overworld").spawnEntity("aq:quest_loader", spawnLoc);
			console.warn("load " + questList.quest.length + " quest and " + guildShopList.list.length + " shop item");
			summon_quest_list.addTag(JSON.stringify(questList));
			summon_quest_list.addTag(JSON.stringify(guildShopList));
			summon_quest_list.addTag("load_quest");
			summon_quest_list.triggerEvent("load_quest");
			system.clearRun(loopId);
		}
	});
}else{
	console.warn("please use adventure quest addon to load quests");
}

const tall_door_list = [ 
	"kd:acacia_tall_door_item", 
	"kd:bamboo_tall_door_item", 
	"kd:birch_tall_door_item", 
	"kd:crimson_tall_door_item", 
	"kd:dark_oak_tall_door_item", 
	"kd:jungle_tall_door_item", 
	"kd:mangrove_tall_door_item", 
	"kd:oak_tall_door_item", 
	"kd:quartz_tall_door_item", 
	"kd:quartz_door_item", 
	"kd:spruce_tall_door_item", 
	"kd:stone_tall_door_item", 
	"kd:stone_door_item", 
	"kd:warped_tall_door_item", 
	"kd:iron_bars_tall_door_item", 
	"kd:door_template_item"
]

const door_list = [ 
	"kd:acacia_chiseled_door_item", 
	"kd:bamboo_chiseled_door_item", 
	"kd:birch_chiseled_door_item", 
	"kd:crimson_chiseled_door_item", 
	"kd:dark_oak_chiseled_door_item", 
	"kd:jungle_chiseled_door_item", 
	"kd:mangrove_chiseled_door_item", 
	"kd:oak_chiseled_door_item", 
	"kd:iron_bars_chiseled_door_item", 
	"kd:iron_bars_door_item", 
	"kd:quartz_chiseled_door_item", 
	"kd:quartz_door_item", 
	"kd:spruce_chiseled_door_item", 
	"kd:stone_chiseled_door_item", 
	"kd:stone_door_item", 
	"kd:warped_chiseled_door_item", 
	"kd:door_template_item",
	"kd:acacia_lited_door_item", 
	"kd:bamboo_lited_door_item", 
	"kd:birch_lited_door_item", 
	"kd:crimson_lited_door_item", 
	"kd:dark_oak_lited_door_item", 
	"kd:jungle_lited_door_item", 
	"kd:mangrove_lited_door_item", 
	"kd:oak_lited_door_item", 
	"kd:vintage_elevator_door_item", 
	"kd:quartz_lited_door_item", 
	"kd:spruce_lited_door_item", 
	"kd:stone_lited_door_item", 
	"kd:warped_lited_door_item"
]

function offset(loc, dx, dy, dz){
	return { x: loc.x+dx, y: loc.y+dy, z: loc.z+dz};
};

world.events.beforeItemUseOn.subscribe(s => {
	if(door_list.includes(s.item.typeId) && s.blockFace == "up"){
		let block_scan = s.getBlockLocation();
		block_scan.y += 2;
		s.cancel = s.source.dimension.getBlock(block_scan).typeId != "minecraft:air";
	}else if(tall_door_list.includes(s.item.typeId) && s.blockFace == "up"){
		let block_scan = s.getBlockLocation();
		let block_scan_top = s.getBlockLocation();
		block_scan_top.y += 3;
		block_scan.y += 2;
		s.cancel = s.source.dimension.getBlock(block_scan).typeId != "minecraft:air" || s.source.dimension.getBlock(block_scan_top).typeId != "minecraft:air";
	}else if(s.item.typeId == "kd:lock_item" && s.source.isSneaking){
		let get_source = s.source;
		let top_loc = s.getBlockLocation();
		let door_hinge_name = (get_source.dimension.getBlock(top_loc).hasTag("door")) ? "door:door_hinge_bit" : "door_hinge_bit";
		
		if(get_source.dimension.getBlock(top_loc).permutation.getProperty(door_hinge_name)){
			let parent_loc = s.getBlockLocation();
			let lock = get_source.dimension.spawnEntity("kd:lock", parent_loc);
			let lock_id = "LOCK" + lock.id;
			let upper_block_name = (get_source.dimension.getBlock(parent_loc).hasTag("door")) ? "door:upper_block_bit" : "upper_block_bit";
			let direction_name = (get_source.dimension.getBlock(parent_loc).hasTag("door")) ? "door:direction" : "direction";
			lock.addTag(lock_id);
			while(!get_source.dimension.getBlock(parent_loc).permutation.getProperty(upper_block_name).value == false){
				parent_loc.y -= 1;
				get_source.dimension.spawnEntity("kd:lock", parent_loc).addTag(lock_id);
			}
			top_loc.y += 1;
			while(get_source.dimension.getBlock(top_loc).permutation.getProperty(upper_block_name) && !get_source.dimension.getBlock(top_loc).permutation.getProperty(upper_block_name).value == false){
				get_source.dimension.spawnEntity("kd:lock", top_loc).addTag(lock_id);
				top_loc.y += 1;
			}
			top_loc.y -= 1;
			
			let get_door_dir = get_source.dimension.getBlock(parent_loc).permutation.getProperty(direction_name).value;
			let child_loc = { x: parent_loc.x, y: parent_loc.y, z: parent_loc.z};
			let param_loc = { x: parent_loc.x, y: parent_loc.y+1, z: parent_loc.z};
			let left_scan = { x: parent_loc.x, y: parent_loc.y, z: parent_loc.z};
			let right_scan = { x: parent_loc.x, y: parent_loc.y, z: parent_loc.z};
			
			left_scan.y += 1;
			right_scan.y += 1;
			
			switch(get_door_dir){
				case 0:
					left_scan.z -= 1;
					right_scan.z += 1;
				break;
				case 1:
					left_scan.x += 1;
					right_scan.x -= 1;
				break;
				case 2:
					left_scan.z += 1;
					right_scan.z -= 1;
				break;
				case 3:
					left_scan.x -= 1;
					right_scan.x += 1;
				break;
			}
			
			let left_scan_dir = { x: left_scan.x, y: left_scan.y-1, z: left_scan.z};
			let right_scan_dir = { x: right_scan.x, y: right_scan.y-1, z: right_scan.z};
			
			let first_pos = parent_loc;
			
			if(get_source.dimension.getBlock(right_scan).permutation.getProperty(door_hinge_name) && get_source.dimension.getBlock(right_scan).permutation.getProperty(upper_block_name).value && get_source.dimension.getBlock(right_scan_dir).permutation.getProperty(direction_name).value == get_door_dir && (get_source.dimension.getBlock(param_loc).permutation.getProperty(upper_block_name).value == true && get_source.dimension.getBlock(param_loc).permutation.getProperty(door_hinge_name).value == false) && (get_source.dimension.getBlock(right_scan).permutation.getProperty(upper_block_name).value == true && get_source.dimension.getBlock(right_scan).permutation.getProperty(door_hinge_name).value == true)){
				child_loc.x = right_scan.x;
				child_loc.z = right_scan.z;
			}else if(get_source.dimension.getBlock(left_scan).permutation.getProperty(door_hinge_name) && get_source.dimension.getBlock(left_scan).permutation.getProperty(upper_block_name).value && get_source.dimension.getBlock(left_scan_dir).permutation.getProperty(direction_name).value == get_door_dir && (get_source.dimension.getBlock(param_loc).permutation.getProperty(upper_block_name).value == true && get_source.dimension.getBlock(param_loc).permutation.getProperty(door_hinge_name).value == true) && (get_source.dimension.getBlock(left_scan).permutation.getProperty(upper_block_name).value == true && get_source.dimension.getBlock(left_scan).permutation.getProperty(door_hinge_name).value == false)){
				child_loc.x = left_scan.x;
				child_loc.z = left_scan.z;
			}
		
			
			if(!(child_loc.x == parent_loc.x && child_loc.y == parent_loc.y && child_loc.z == parent_loc.z) && !get_source.dimension.getBlock(child_loc).permutation.getProperty(upper_block_name).value){
				get_source.dimension.spawnEntity("kd:lock", child_loc).addTag(lock_id);
				child_loc.y += 1;
				while(get_source.dimension.getBlock(child_loc).permutation.getProperty(upper_block_name) && !get_source.dimension.getBlock(child_loc).permutation.getProperty(upper_block_name).value == false){
					get_source.dimension.spawnEntity("kd:lock", child_loc).addTag(lock_id);
					child_loc.y += 1;
				}
				child_loc.y -= 1;
			}else{
				child_loc = top_loc;
			}
			let mid_x = (parent_loc.x+child_loc.x)/2+0.5;
			let mid_y = (parent_loc.y+child_loc.y)/2;
			let mid_z = (parent_loc.z+child_loc.z)/2+0.5;
			
			let lock_icon = get_source.dimension.spawnEntity("kd:lock", { x: (parent_loc.x+child_loc.x)/2, y: (parent_loc.y+child_loc.y)/2, z: (parent_loc.z+child_loc.z)/2});
			lock_icon.addTag(lock_id);
			lock_icon.getComponent("minecraft:mark_variant").value = get_door_dir;
			lock_icon.teleport({ x: mid_x, y: mid_y, z: mid_z }, get_source.dimension, 0, 0 );
			lock_icon.triggerEvent("set_icon");
			
			let key = new ItemStack(ItemTypes.get("kd:lock_key"));
			key.setLore( [ "\n§r§9Lock ID: " + lock_id ] );
			get_source.getComponent("minecraft:inventory").container.setItem(get_source.selectedSlot, key);
		}
	}
});

world.events.entityHit.subscribe(s => {
	if(s.hitEntity && s.hitEntity.typeId == "kd:lock"){
		let lock_id = s.hitEntity.getTags()[0];
		let lock_display = "Lock ID: " + lock_id;
		let player_name = s.entity.nameTag;
		let item = s.entity.getComponent("minecraft:inventory").container.getItem(s.entity.selectedSlot);
		if(item && item.typeId == "kd:lock_key" && item.getLore()[0] == "\n§r§9" + lock_display){
			let lock = new ItemStack(ItemTypes.get("kd:lock_item"));
			s.entity.getComponent("minecraft:inventory").container.setItem(s.entity.selectedSlot, lock);
			s.hitEntity.runCommandAsync("playsound random.metal.door_open @a ~ ~ ~ 1 2");
			s.entity.runCommandAsync("event entity @e[type=kd:lock, tag=" + lock_id + "] despawn");
		}else if(item && item.typeId == "kd:lock_pick"){
			item.amount -= Array.from(world.getPlayers( { excludeGameModes: [ "creative" ], name: player_name})).length;
			s.entity.getComponent("minecraft:inventory").container.setItem(s.entity.selectedSlot, item);
			s.hitEntity.triggerEvent("use_lock_pick");
			s.hitEntity.runCommandAsync("playsound random.break @a ~ ~ ~ 0.5 3");
		}else{
			s.entity.onScreenDisplay.setActionBar(lock_display);
		}
	}
	
}, { entityTypes: [ "minecraft:player" ] });

world.events.dataDrivenEntityTriggerEvent.subscribe(s => {
	if(s.id == "kd:unlock" || (s.id == "loc_refresh" && s.entity.velocity.x != 0)){
		s.entity.runCommandAsync("event entity @e[type=kd:lock, tag=" + s.entity.getTags()[0] + "] despawn");
		
	}else if(s.id == "loc_refresh"){
		let get_block = s.entity.dimension.getBlock({ x: Math.floor(s.entity.location.x), y: Math.floor(s.entity.location.y), z: Math.floor(s.entity.location.z)});
		if(get_block.permutation.getProperty("door_hinge_bit") || get_block.permutation.getProperty("door:door_hinge_bit")){
			let open_name = get_block.permutation.getProperty("door_hinge_bit") ? "open_bit" : "door:open_bit";
			let block_condition = get_block.permutation.clone();
			block_condition.getProperty(open_name).value = false;
			get_block.setPermutation(block_condition);
		}
	}
}, { entityTypes: [ "kd:lock" ] });

world.events.blockBreak.subscribe(s => {
	if(s.brokenBlockPermutation.getProperty("door:top") && s.brokenBlockPermutation.getProperty("door:top")){
		let block_scan = s.block.location;
		block_scan.y -= 1;
		s.block.dimension.getBlock(block_scan).setType(MinecraftBlockTypes.air);
	}
});

function blockSetProp(blockWorld, loc, prop, replace){
	let propD = prop.getAllProperties();
	let propL = Object.keys(propD);
	let propLen = propL.length;
	let dataBlock = "";
	let i = 0;
	for(let data of propL){
		let str = propD[data.toString()];
		if(data.toString() == "door:open_bit") str = replace;
		if (typeof str === "string") {
			dataBlock += "\"" + data.toString() + "\":\"" + str + ((i < propLen-1) ? "\", " : "\"");
		}else{
			dataBlock += "\"" + data.toString() + "\":" + str + ((i < propLen-1) ? ", " : "");
		}
		i++;
	}
	blockWorld.runCommandAsync("setblock " + loc.x + " " + loc.y + " " + loc.z + " " + prop.type.id + " [" + dataBlock + "] replace");
}

function blockSetProp2(blockWorld, loc, prop, replace, replace2){
	let propD = prop.getAllProperties();
	let propL = Object.keys(propD);
	let propLen = propL.length;
	let dataBlock = "";
	let i = 0;
	for(let data of propL){
		let str = propD[data.toString()];
		if(data.toString() == "door:open_bit"){
			str = replace;
		}else if(data.toString() == "door:powered"){
			str = replace2;
		}
		if (typeof str === "string") {
			dataBlock += "\"" + data.toString() + "\":\"" + str + ((i < propLen-1) ? "\", " : "\"");
		}else{
			dataBlock += "\"" + data.toString() + "\":" + str + ((i < propLen-1) ? ", " : "");
		}
		i++;
	}
	blockWorld.runCommandAsync("setblock " + loc.x + " " + loc.y + " " + loc.z + " " + prop.type.id + " [" + dataBlock + "] replace");
}

function door_sound(blockPar){
	let soundType  = "wood";
	if(blockPar.hasTag("metal")){
		soundType = "metal";
	}else if(blockPar.hasTag("bamboo")){
		soundType = "bamboo";
	}else if(blockPar.hasTag("stone") || blockPar.hasTag("nether")){
		soundType = "heavy";
	}
	
	if(!blockPar.permutation.getProperty("door:open_bit")){
		blockPar.dimension.runCommandAsync("playsound random." + soundType + ".door_open @a " + blockPar.location.x + " " + + blockPar.location.y + " " + + blockPar.location.z);
	}else{
		blockPar.dimension.runCommandAsync("playsound random." + soundType + ".door_close @a " + blockPar.location.x + " " + + blockPar.location.y + " " + + blockPar.location.z);
	}
}

function interact_door(blockPar){
	door_sound(blockPar);
	let dim = blockPar.dimension;
	let blockPos = blockPar.location;
	let condition = !blockPar.permutation.getProperty("door:open_bit");
	blockSetProp(dim, blockPos, blockPar.permutation, condition);
	let go_up = 1
	
	while(blockPar.dimension.getBlock(offset(blockPos, 0, go_up, 0)).hasTag("door") && blockPar.dimension.getBlock(offset(blockPos, 0, go_up, 0)).permutation.getProperty("door:upper_block_bit") == true){
		let offsetB = offset(blockPos, 0, go_up, 0)
		blockSetProp(dim, offsetB, blockPar.dimension.getBlock(offsetB).permutation, condition);
		go_up += 1;
	}
	let go_down = 0;
	while(blockPar.dimension.getBlock(offset(blockPos, 0, go_down, 0)).hasTag("door") && blockPar.dimension.getBlock(offset(blockPos, 0, go_down, 0)).permutation.getProperty("door:upper_block_bit") == true){
		go_down -= 1;
		let offsetB = offset(blockPos, 0, go_down, 0)
		blockSetProp(dim, offsetB, blockPar.dimension.getBlock(offsetB).permutation, condition);
	}
}

system.events.scriptEventReceive.subscribe(s => {
    if(s.message == "bottom_check"){
		
		let blockPar = s.sourceBlock;
		let blockPos = blockPar.location;
		if(blockPar.dimension.getBlock(offset(blockPos, 0, -1, 0)).typeId == "minecraft:air" && blockPar.permutation.getProperty("door:upper_block_bit") == false){
			blockPar.dimension.getBlock(offset(blockPos, 0, 1, 0)).setType(MinecraftBlockTypes.air);
		}
		
		if(blockPar.permutation.getProperty("door:powered") != undefined){
			
			let dim = blockPar.dimension;
			let get_lock = Array.from(blockPar.dimension.getEntitiesAtBlockLocation(blockPos));
			let has_locked = false;
			for(let entity_in_door of get_lock){
				if(entity_in_door.typeId == "kd:lock"){
					has_locked = true;
					break;
				}
			}
			if(!has_locked){
				let power = blockPar.dimension.getBlock(offset(blockPos, 0, -1, 0)).getRedstonePower() > 0;
				let go_up = 0;
				while(blockPar.dimension.getBlock(offset(blockPos, 0, go_up, 0)).hasTag("door") && (blockPar.dimension.getBlock(offset(blockPos, 0, go_up, 0)).permutation.getProperty("door:upper_block_bit") == true || go_up == 0) && !power){
					if(blockPar.dimension.getBlock(offset(blockPos, 0, go_up, 1)).getRedstonePower() > 0){
						power = true;
					}else if(blockPar.dimension.getBlock(offset(blockPos, 0, go_up, -1)).getRedstonePower() > 0 && !power){
						power = true
					}else if(blockPar.dimension.getBlock(offset(blockPos, 1, go_up, 0)).getRedstonePower() > 0 && !power){
						power = true
					}else if(blockPar.dimension.getBlock(offset(blockPos, -1, go_up, 0)).getRedstonePower() > 0 && !power){
						power = true
					}
					if(power) break;
					go_up++;
				}
				
				if(power != blockPar.permutation.getProperty("door:powered")){
					door_sound(blockPar);
					let condition = power;
					blockSetProp2(dim, blockPar.location, blockPar.permutation, condition, power ? 1 : 0);
					
					
					let go_down = 0;
					let go_up = 1;
					while(blockPar.dimension.getBlock(offset(blockPos, 0, go_down, 0)).hasTag("door") && blockPar.dimension.getBlock(offset(blockPos, 0, go_down, 0)).permutation.getProperty("door:upper_block_bit") == true){
						go_down -= 1;
						let offsetB = offset(blockPos, 0, go_down, 0);
						blockSetProp(dim, offsetB, blockPar.dimension.getBlock(offsetB).permutation, condition);
					}
					while(blockPar.dimension.getBlock(offset(blockPos, 0, go_up, 0)).hasTag("door") && blockPar.dimension.getBlock(offset(blockPos, 0, go_up, 0)).permutation.getProperty("door:upper_block_bit") == true){
						let offsetB = offset(blockPos, 0, go_up, 0);
						blockSetProp(dim, offsetB, blockPar.dimension.getBlock(offsetB).permutation, condition);
						go_up += 1;
					}
				}
			}
		}
	}else if(s.message == "interact_stable"){
		let blockPar = s.sourceBlock;
		let blockPos = blockPar.location;
		interact_door(blockPar);
	}else if(s.message == "interact"){
		let blockPar = s.sourceBlock;
		let blockPos = blockPar.location;
		let ancor = 0;
		while(blockPar.dimension.getBlock(offset(blockPos, 0, ancor, 0)).hasTag("door") && blockPar.dimension.getBlock(offset(blockPos, 0, ancor, 0)).permutation.getProperty("door:upper_block_bit") == true){
			ancor -= 1;
		}
		interact_door(blockPar.dimension.getBlock(offset(blockPos, 0, ancor, 0)));
	}
}, { namespaces: [ "door" ]}); 

/*
system.events.scriptEventReceive.subscribe(s => {
    if(s.message == "target"){
		s.sourceEntity.addTag("use_duplicator");
	}else if(s.message == "duplicate"){
		let lock_id = Array.from(s.sourceBlock.dimension.getEntitiesAtlocation(s.sourceBlock.location))[0];
		let lock_container = lock_id.getComponent("minecraft:inventory").container;
		let lockID = lock_container.getSlot(0).getLore()[0];
		let otherID = lock_container.getSlot(1).getLore();
		otherID[0] = lockID;
		lock_container.getSlot(1).setLore(otherID);
		s.sourceBlock.dimension.spawnItem(lock_container.getSlot(0), s.sourceBlock.location);
		s.sourceBlock.dimension.spawnItem(lock_container.getSlot(1), s.sourceBlock.location);
		lock_container.clearAll();
	}else{
		let target_player = Array.from(s.sourceBlock.dimension.getPlayers({ tags: [ "use_duplicator" ]}))[0];
		let item_hand = target_player.getComponent("minecraft:inventory").container.getItem(target_player.selectedSlot);
		if(item_hand.typeId == "kd:lock_key" && ((s.message == "0" && item_hand.getLore().length > 0 && item_hand.getLore()[0].split(":")[0] == "\n§r§9Lock ID") || (s.message == "1" && item_hand.getLore().length == 0))){
			let loc = s.sourceBlock.location;
			let lock_id = Array.from(s.sourceBlock.dimension.getEntitiesAtlocation(s.sourceBlock.location))[0];
			let lock_container = lock_id.getComponent("minecraft:inventory").container;
			let target_container = target_player.getComponent("minecraft:inventory").container;
			if(s.message == "0"){
				lock_container.setItem(0, item_hand);
			}else if(s.message == "1"){
				lock_container.setItem(1, item_hand);
			}
			let block_set = s.sourceBlock.permutation.clone();
			block_set.getProperty("kd:key").value = s.message == "0" ? 1 : 2;
			s.sourceBlock.setPermutation(block_set);
		}else{
			let duplicate_display = s.message == "0" ? "Select key with Lock ID" : "Select empty key";
			target_player.onScreenDisplay.setActionBar(duplicate_display);
		}
		
		target_player.removeTag("use_duplicator");
	}
}, { namespaces: [ "duplicator" ]}); 
*/